﻿Imports System.Text


Public Class MyCollectionEnumerator
    Implements IEnumerator(Of CustomListDataItem)

    Private current_Renamed As Integer = 0
    Private owner As RadMultiSelectDropDownList
    Private ownerCollection As MyDynamicCollection

    Public Sub New(ByVal owner As RadMultiSelectDropDownList, ByVal ownerCollection As MyDynamicCollection)
        Me.owner = owner
        Me.ownerCollection = ownerCollection
    End Sub

    Public ReadOnly Property Current() As CustomListDataItem Implements IEnumerator(Of CustomListDataItem).Current
        Get
            Return CType(owner.Items(current_Renamed), CustomListDataItem)
        End Get
    End Property

    Public Sub Dispose() Implements IDisposable.Dispose

    End Sub

    Private ReadOnly Property IEnumerator_Current() As Object Implements System.Collections.IEnumerator.Current
        Get
            Return Me.Current
        End Get
    End Property

    Public Function MoveNext() As Boolean Implements System.Collections.IEnumerator.MoveNext
        If current_Renamed < ownerCollection.Count - 1 Then
            current_Renamed += 1
            Return True
        End If

        Return False
    End Function

    Public Sub Reset() Implements System.Collections.IEnumerator.Reset
        current_Renamed = 0
    End Sub
End Class
